#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>

#define JUDYERROR_SAMPLE 1
#include <Judy.h>

#define MAX_STR_SIZE 128

/* creating the dynamic array */
Pvoid_t 	array = (PWord_t)NULL;

void
put(char *buffer)
{
	char *key, *value, *aux;
	PWord_t p_value;

	/* parsing values */
	key = buffer + 4;

	if ((aux = strchr(key, ' ')) == NULL) {
		puts("error parsing");
		return;
	}
	aux[0] = '\0';

	/* allocating memory */
	value = strdup(aux+1);

	/* lookup */
	JSLI(p_value, array, (uint8_t *)key);

	/* buy some more RAM... */
	if (p_value == PJERR) {
		puts("Sorry, we're out of memory\n");
		exit(1);
	}

	/* insert value into the array */
	*p_value = (Word_t)value;
}

void
get(char *buffer)
{
	char *key;
	PWord_t p_value;

	/* parsing values */
	key = buffer + 4;

	/* lookup */
	JSLG(p_value, array, (uint8_t *)key);

	/* printing value */
	if (p_value != NULL)
		printf("%s %s\n", key, (char *)*p_value);
	else
		puts("NAO ENCONTRADO");
}

void
delete(char *buffer)
{
	char 	*key;
	PWord_t	p_value;
	Word_t	ret_code;

	/* parsing value */
	key = buffer + 7;

	/* since JSLD does not return a pointer to our string,
	 * here we must lookup twice =( */
	JSLG(p_value, array, (uint8_t *)key);

	if (p_value != NULL) {
		free((void *)*p_value);
		JSLD(ret_code, array, (uint8_t *)key);
	}
	else
		puts("NAO ENCONTRADO");
}

void
print()
{
	char 	index[MAX_STR_SIZE];
	PWord_t p_value;

	index[0] = '\0';
	puts("Início agenda");

	/* lookup the table */
	JSLF(p_value, array, (uint8_t *)index);

	while (p_value) {
		printf("%s %s\n", index, (char *)*p_value);
		JSLN(p_value, array, (uint8_t *)index);
	}

	puts("Fim agenda");
}

int
main(int argc, char **argv)
{
	char 		*buffer;
	size_t 		readed, len = 0;


	// reading entire lines
	while ((readed = getline(&buffer, &len, stdin)) != -1) {
		buffer[readed-1] = '\0';

		// GET
		if (strncmp(buffer, "GET ", 4) == 0)
			get(buffer);

		// PUT
		else if (strncmp(buffer, "PUT ", 4) == 0)
			put(buffer);

		// DELETE
		else if (strncmp(buffer, "DELETE ", 7) == 0)
			delete(buffer);

		// PRINT
		else if (strncmp(buffer, "PRINT", 5) == 0)
			print();

		else
			puts("parse error");
	}
	return 0;
}
